module.exports = {
    masterInit: (app) => {
        return (routePrefix, pushEdit, editCheck, router, model) => {
            return {
                string: async function (req, res, name, match) {
                    if (!req.params.id) {return;}
                    const document = await model.findOne({id: req.params.id.toLowerCase()});
                    if (!editCheck(document, req, res)) {return;}
                    const camelName = app.util.bodyCase(name);
                    if (!req.body[camelName]) {return res.status(400).send(`You did not provide a new ${camelName} in your body.`);}
                    if (!match(req.body[camelName])) {return res.status(400).send(`Your new ${camelName} is too long or contains illegal characters.`);}
                    try {
                        document[camelName] = req.body[camelName].trim();
                        pushEdit(`Updated ${camelName}`, req, document);
                        return document.save()
                            .then(() => res.send(`${camelName.charAt(0).toUpperCase()}${camelName.slice(1)} updated.`))
                            .catch(() => res.status(500).send(`There was an error trying to update your ${camelName}. Please try again.`));
                    } catch {return res.status(500).send(`There was an error trying to update your ${camelName}. Please try again.`);}
                },

                stringWrap: function (name, match) {
                    const route = router.route(`${routePrefix}/${name}`);
                    route.patch(app.auth.token, app.auth.permsPass('series-approve'), async (req, res) => {
                        await this.string(req, res, name, match).catch(() => res.status(500).send(`There was an error trying to update your ${name}. Please try again.`));
                    });
                    return route
                }
            }
        }
    }
}